
#INCLUDE ZX81HDR.ASM




;SOME ZX81 SYSTEM VARS THAT MIGHT BE USEFUL

;NOW SOME SYSTEM VARIABLES THAT MAY BE OF USE

#DEFINE D_FILE		$400C		;START OF DISPLAY FILE
#DEFINE LAST_K		$4025		;LAST KEYS PRESSED
#DEFINE FRAMES		$4034		;FRAMES COUNTER

;AND SOME ROM ADDRESSES
 
#DEFINE ROM_SETFAST	$0F23		;ROM CALL SETS FAST MODE
#DEFINE ROM_CLS	$0A2A		;ROM CALL CLS
#DEFINE ROM_SLOW	$0F2B		;ROM CALL SLOW MODE



CODE_START:
		CALL	ROM_CLS			;MAKE SURE WE HAVE A "FULL" D-FILE	
		CALL	ROM_SLOW			;ALSO SLOW MODE !
		;CALL INITIALISE
		

		LD	BC,0			;BC IS USED TO HOLD X/Y COORDS
LOOP:
		PUSH	BC			;SAVE X/Y FOR NEXT ITTERATION
		CALL	PLOT
		
		POP	BC			;GET CO-ORDS BACK
		
		
		INC 	B			;SWEEP X-CORD ACCROSS SCREEN
		
		BIT	6,B			;IS 64 YET?	
		JR	Z,LOOP
		LD	B,0
		INC	C			;NEXT ROW
		
		LD	A,48
		CP	C			;REACHED 48 YET?
		JR	NZ,LOOP
		RET				;BACK TO BASIC
				



		
PLOT:

CALC_DFILE_BYTE:
;WORK OUT SCREEN BYTE FROM CO-ORDS
	LD	A,C			;GET CURRENT Y POSITION 0 TO 47
	SRL	A			;A = 0 TO 23
					
	LD	E,A			;E = 1 * A
	
	LD	D,0			;DE = 1 *  A
	ADD	A,A			;A = 2* ,	MAX = 46
	ADD	A,A			;A = 4 *  , MAX = 92
	ADD	A,A			;A = 8 * , MAX =184
	ADD	A,A			;A = 16 Y , MAX = 112 AND CARRY SET
	LD 	H,0			;NO EFFECT ON CARRY
	RL	H			;PICK UP ANY CARRY	
	LD	L,A
	ADD	HL,HL		;HL = 32 * Y
	ADD	HL,DE		;HL = 33 * Y
	
	
	
	LD	A,B			;GET X POSITION 
	SRL	A			;DIVIDE BY 2
	LD	E,A
	LD	D,0			
	ADD	HL,DE		;HL NOW = SCREEN OFFSET
	LD	DE,(D_FILE)
	ADD	HL,DE		;HL NOW = CURRENT DFILE + OFFSET
	
	INC	HL			;COMPENSATE FOR 1ST HALT IN DFILE
	
;NOW THE TRICKY BIT
;A SINGLE PLOT POINT CAN HAVE A CHARATER VALUE OF 1,2,4 OR 135 
;THIS COULD PROBABLY BE DONE QUICKER IN A LOOKUP TABLE....
	LD	DE,LOOKUP			;	
	XOR	A				; ZERO A
	SRA	B				;BIT 1 INTO CARRY 
	RLA					;CARRY INTO A
	SRA	C				;BIT 1 INTO CARRY
	RLA
	ADD	A,E				;NOTE NO CHECK THAT RESULT > 255
	LD	E,A				
	LD	A,(DE)
	
;IS THAT CODE ABOVE BETTER THAT THIS BELOW ?	
	
; 	LD	A,1
; 	BIT 0,B
; 	JR	Z,EVEN_X
; 	LD	A,2
; ODD_X:
; 	;A=2 BUT COULD BE 135
; 	BIT 0,C
; 	JR	Z,EVEN_Y
; 	LD	A,135
; 	JR	EVEN_Y	
; 	
; 	
; EVEN_X:
; 	;A=1 BUT COULD BE 4
; 	
; 	BIT 0,C
; 	JR	Z,EVEN_Y	
; 	LD	A,4
; 	
; EVEN_Y:	

	
 	RLCA				;ROTATE LEFT, BIT 7 INTO CARRY
 	JR	NC,SKIP_INVERT_1
 	XOR	$0E			;INVERT THE OTHER BITS (WHICH ARE SHIFTED TOO)
SKIP_INVERT_1:
 	LD	C,A			;SAVE IT FOR NOW
 	
 	LD	A,(HL)		;GET THE BYTE FROM DFILE
 	RLCA				;ROTATE IT
 	JR	NC,SKIP_INVERT_2
 	XOR	$0E			;INVERT THE OTHER BITS
SKIP_INVERT_2:
 	OR	C			;MIX IN THE OTHER BYTE
 	RRCA				;ROTATE IT RIGHT
 	JR	NC,SKIP_INVERT_3
 	XOR	$07			;BIT 7 SET. INVERT THE OTHER BITS
SKIP_INVERT_3:
 	AND	$87			;MAKE SURE IT'S A VALID CHAR
 	LD	(HL),A		;WHACK IT IN DFILE
 	
	RET

;WOUDL BE BETTER ON A PAGE BOUNDARY

LOOKUP:
	DB	1,4,2,135

;--------------
;end of my code
;--------------		
		
#INCLUDE ZX81END.ASM

